drop table VEN_ESCAN_BITACORA CASCADE CONSTRAINTS;

CREATE TABLE VEN_ESCAN_BITACORA
(
  ESCANID       VARCHAR2(25) NOT NULL,
  SECUENCIA     NUMBER(3) NOT NULL,
  DESCRIPCION   VARCHAR2(1024),
  TIPO          CHAR(2) DEFAULT 'AA' NOT NULL 
    CONSTRAINT VEN_ESCAN_BITACORA_TIPO_CK CHECK (tipo IN ('CN','AA','AN','CS','AI')),
  PRIMARY KEY(CAJA,ESCANID,SECUENCIA)
);

 
drop table VEN_ESCAN_ORDENCOM;


CREATE TABLE VEN_ESCAN_ORDENCOM
(
  CAJA          CHAR(3) DEFAULT '001' NOT NULL,
  ESCANID       VARCHAR2(25),
  REALIZADOPOR  NUMBER(1),
  COD_ZONA      VARCHAR2(2),
  COD_CLIENTE   VARCHAR2(25),
  ADISCATANT    NUMBER(3),
  ADISCAT       NUMBER(3),
  NUMCAT        NUMBER(3),
  PEDIDO        NUMBER(10),
  FECHA         DATE DEFAULT SYSDATE NOT NULL,
  COD1          NUMBER(6),
  UNID1         NUMBER(6),
  CODSN31       NUMBER(6),
  COD2          NUMBER(6),
  UNID2         NUMBER(6),
  CODSN32       NUMBER(6),
  COD3          NUMBER(6),
  UNID3         NUMBER(6),
  CODSN33       NUMBER(6),
  COD4          NUMBER(6),
  UNID4         NUMBER(6),
  CODSN34       NUMBER(6),
  COD5          NUMBER(6),
  UNID5         NUMBER(6),
  CODSN35       NUMBER(6),
  COD6          NUMBER(6),
  UNID6         NUMBER(6),
  CODSN36       NUMBER(6),
  COD7          NUMBER(6),
  UNID7         NUMBER(6),
  COD8          NUMBER(6),
  UNID8         NUMBER(6),
  COD9          NUMBER(6),
  UNID9         NUMBER(6),
  COD10         NUMBER(6),
  UNID10        NUMBER(6),
  COD11         NUMBER(6),
  UNID11        NUMBER(6),
  COD12         NUMBER(6),
  UNID12        NUMBER(6),
  COD13         NUMBER(6),
  UNID13        NUMBER(6),
  COD14         NUMBER(6),
  UNID14        NUMBER(6),
  COD15         NUMBER(6),
  UNID15        NUMBER(6),
  COD16         NUMBER(6),
  UNID16        NUMBER(6),
  COD17         NUMBER(6),
  UNID17        NUMBER(6),
  COD18         NUMBER(6),
  UNID18        NUMBER(6),
  COD19         NUMBER(6),
  UNID19        NUMBER(6),
  COD20         NUMBER(6),
  UNID20        NUMBER(6),
  COD21         NUMBER(6),
  UNID21        NUMBER(6),
  COD22         NUMBER(6),
  UNID22        NUMBER(6),
  COD23         NUMBER(6),
  UNID23        NUMBER(6),
  COD24         NUMBER(6),
  UNID24        NUMBER(6),
  COD25         NUMBER(6),
  UNID25        NUMBER(6),
  COD26         NUMBER(6),
  UNID26        NUMBER(6),
  COD27         NUMBER(6),
  UNID27        NUMBER(6),
  COD28         NUMBER(6),
  UNID28        NUMBER(6),
  COD29         NUMBER(6),
  UNID29        NUMBER(6),
  COD30         NUMBER(6),
  UNID30        NUMBER(6),
  COD31         NUMBER(6),
  UNID31        NUMBER(6),
  COD32         NUMBER(6),
  UNID32        NUMBER(6),
  COD33         NUMBER(6),
  UNID33        NUMBER(6),
  COD34         NUMBER(6),
  UNID34        NUMBER(6),
  COD35         NUMBER(6),
  UNID35        NUMBER(6),
  COD36         NUMBER(6),
  UNID36        NUMBER(6),
  COD37         NUMBER(6),
  UNID37        NUMBER(6),
  COD38         NUMBER(6),
  UNID38        NUMBER(6),
  COD39         NUMBER(6),
  UNID39        NUMBER(6),
  COD40         NUMBER(6),
  UNID40        NUMBER(6),
  COD41         NUMBER(6),
  UNID41        NUMBER(6),
  COD42         NUMBER(6),
  UNID42        NUMBER(6),
  COD43         NUMBER(6),
  UNID43        NUMBER(6),
  COD44         NUMBER(6),
  UNID44        NUMBER(6),
  COD45         NUMBER(6),
  UNID45        NUMBER(6),
  COD46         NUMBER(6),
  UNID46        NUMBER(6),
  COD47         NUMBER(6),
  UNID47        NUMBER(6),
  COD48         NUMBER(6),
  UNID48        NUMBER(6),
  COD49         NUMBER(6),
  UNID49        NUMBER(6),
  COD50         NUMBER(6),
  UNID50        NUMBER(6),
  COD51         NUMBER(6),
  UNID51        NUMBER(6),
  COD52         NUMBER(6),
  UNID52        NUMBER(6),
  COD53         NUMBER(6),
  UNID53        NUMBER(6),
  COD54         NUMBER(6),
  UNID54        NUMBER(6),
  COD55         NUMBER(6),
  UNID55        NUMBER(6),
  COD56         NUMBER(6),
  UNID56        NUMBER(6),
  COD57         NUMBER(6),
  UNID57        NUMBER(6),
  COD58         NUMBER(6),
  UNID58        NUMBER(6),
  COD59         NUMBER(6),
  UNID59        NUMBER(6),
  COD60         NUMBER(6),
  UNID60        NUMBER(6),
  COD61         NUMBER(6),
  UNID61        NUMBER(6),
  COD62         NUMBER(6),
  UNID62        NUMBER(6),
  COD63         NUMBER(6),
  UNID63        NUMBER(6),
  COD64         NUMBER(6),
  UNID64        NUMBER(6),
  COD65         NUMBER(6),
  UNID65        NUMBER(6),
  COD66         NUMBER(6),
  UNID66        NUMBER(6),
  COD67         NUMBER(6),
  UNID67        NUMBER(6),
  COD68         NUMBER(6),
  UNID68        NUMBER(6),
  COD69         NUMBER(6),
  UNID69        NUMBER(6),
  COD70         NUMBER(6),
  UNID70        NUMBER(6),
  COD71         NUMBER(6),
  UNID71        NUMBER(6),
  COD72         NUMBER(6),
  UNID72        NUMBER(6),
  COD73         NUMBER(6),
  UNID73        NUMBER(6),
  COD74         NUMBER(6),
  UNID74        NUMBER(6),
  COD75         NUMBER(6),
  UNID75        NUMBER(6),
  COD76         NUMBER(6),
  UNID76        NUMBER(6),
  COD77         NUMBER(6),
  UNID77        NUMBER(6),
  COD78         NUMBER(6),
  UNID78        NUMBER(6),
  COD79         NUMBER(6),
  UNID79        NUMBER(6),
  COD80         NUMBER(6),
  UNID80        NUMBER(6),
  COD81         NUMBER(6),
  UNID81        NUMBER(6),
  COD82         NUMBER(6),
  UNID82        NUMBER(6),
  COD83         NUMBER(6),
  UNID83        NUMBER(6),
  COD84         NUMBER(6),
  UNID84        NUMBER(6),
  COD85         NUMBER(6),
  UNID85        NUMBER(6),
  COD86         NUMBER(6),
  UNID86        NUMBER(6),
  COD87         NUMBER(6),
  UNID87        NUMBER(6),
  COD88         NUMBER(6),
  UNID88        NUMBER(6),
  COD89         NUMBER(6),
  UNID89        NUMBER(6),
  COD90         NUMBER(6),
  UNID90        NUMBER(6),
  COD91         NUMBER(6),
  UNID91        NUMBER(6),
  COD92         NUMBER(6),
  UNID92        NUMBER(6),
  COD93         NUMBER(6),
  UNID93        NUMBER(6),
  COD94         NUMBER(6),
  UNID94        NUMBER(6),
  COD95         NUMBER(6),
  UNID95        NUMBER(6),
  COD96         NUMBER(6),
  UNID96        NUMBER(6),
  COD97         NUMBER(6),
  UNID97        NUMBER(6),
  COD98         NUMBER(6),
  UNID98        NUMBER(6),
  COD99         NUMBER(6),
  UNID99        NUMBER(6),
  COD100        NUMBER(6),
  UNID100       NUMBER(6),
  PRIMARY KEY(CAJA,ESCANID)
)
;


alter table ven_escan_ordencom
add fecha date default sysdate not null;

alter table ven_escan_ordencom
add caja char(3) default '001' not null;

alter table ven_escan_ordencom
drop constraint ven_escan_ordencom_pk;

alter table ven_escan_ordencom
add constraint ven_escan_ordencom_pk PRIMARY KEY (CAJA,ESCANID);


ALTER TABLE VEN_ESCAN_BITACORA
   ADD CONSTRAINT VEN_ESCAN_ORDENCOM_BITA_FK FOREIGN KEY (CAJA,ESCANID)
      REFERENCES VEN_ESCAN_ORDENCOM (CAJA,ESCANID);


alter table ven_escan_ordencom
add autoriza char(1) default 'N' not null;


alter table ven_escan_ordencom
add   COD95         NUMBER(6);
alter table ven_escan_ordencom
add   UNID95        NUMBER(6);
alter table ven_escan_ordencom
add   COD96         NUMBER(6);
alter table ven_escan_ordencom
add   UNID96        NUMBER(6);
alter table ven_escan_ordencom
add   COD97         NUMBER(6);
alter table ven_escan_ordencom
add   UNID97        NUMBER(6);
alter table ven_escan_ordencom
add   COD98         NUMBER(6);
alter table ven_escan_ordencom
add   UNID98        NUMBER(6);
alter table ven_escan_ordencom
add   COD99         NUMBER(6);
alter table ven_escan_ordencom
add   UNID99        NUMBER(6);
alter table ven_escan_ordencom
add   COD100         NUMBER(6);
alter table ven_escan_ordencom
add   UNID100        NUMBER(6);

alter table ven_escan_ordencom
add ADISCATANT    NUMBER(3) default 0 not null;


alter table ven_escan_ordencom
add CONSTRAINT VEN_ESCAN_ORDENCOM_autoriza_CK CHECK (autoriza IN ('N','S'));


/*==============================================================*/
/* Index: VEN_ESCAN_ORDENCOM_IDX                                  */
/*==============================================================*/
CREATE INDEX VEN_ESCAN_ORDENCOM_IDX ON VEN_ESCAN_ORDENCOM (
 COD_ZONA,
 FECHA,
 COD_CLIENTE
);