Create or replace package venlevscan is
   Type Recexp is
      Record (codArt  varchar2(25),
              susArt  varchar2(25),
              canArt  number(14,2));
   Type Tabexp is
      Table of varchar2(25);
   Procedure LleneTabla(pcaja in varchar2,pSid in varchar2);
   Function Siguiente return Recexp;
   Function Conteo return number;
   PROCEDURE RegistraErrorLevPed(Vcaja in varchar2,Vescanid in varchar2,
                     Vsecerr in out number,
                     Verror in varchar2,
                     Vtipoerr in char default 'A');
   PROCEDURE InsertaPedido(pcia in varchar2,psuc in char,pdoc in number,vsec in out number,vlote in varchar2,
                           vbod in varchar2,vart in varchar2,vporcdescuento in number,vmedida in varchar2,
                           pcant in number,Vreservado in number,vprecio in number,vimpuesto in number,
    	                   vtotallinea in number,vpdesc1 in number,vpdesc2 in number,vpdesc3 in number, Verror in out varchar2);
   PROCEDURE MarcaAgotado(pcia in char,Vcatalogo in varchar2,Vart in varchar2);
   FUNCTION PremiosInsatisfechos(Vcia in char,Vsuc in char,Vdocumento in number) RETURN VARCHAR2;
   FUNCTION DevOrdenArt(Vcia in char,Vcat in varchar2,Varticulo in varchar2) RETURN number;
   FUNCTION DevClaveArt(Vcia in char,Vcat in varchar2,Varticulo in varchar2) RETURN varchar2;
   Function VerificaSaldo(pcia in char,plinea in varchar2,pcliente in varchar2) return number;
End Venlevscan;
/


Create or replace package Body VenLevscan is
   vTabla  Tabexp;
   vActual pls_integer;

   Procedure LleneTabla(pcaja in varchar2,pSid in varchar2) is
      Tcv sys_refcursor;
      vR VEN_ESCAN_ORDENCOM%rowtype;
   begin
      OPEN tcv FOR select *
                   from VEN_ESCAN_ORDENCOM
                   where ESCANID=pSid
                   and   caja=pcaja;
      fetch tcv into vR;
      close tcv;
       --La linea que sigue es la que tiene que cambiar por toda la lista poniendo los
       -- sustitutos en su posicion despues de la cantidad
       vTabla:=Tabexp(vR.COD1,vR.UNID1,vR.COD2,vR.UNID2,vR.COD3,vR.UNID3,vR.COD4,vR.UNID4,vR.COD5,vR.UNID5,vR.COD6,vR.UNID6,
                      vR.COD7,vR.UNID7,vR.COD8,vR.UNID8,vR.COD9,vR.UNID9,vR.COD10,vR.UNID10,vR.COD11,vR.UNID11,vR.COD12,vR.UNID12,
                      vR.COD13,vR.UNID13,vR.COD14,vR.UNID14,vR.COD15,vR.UNID15,vR.COD16,vR.UNID16,vR.COD17,vR.UNID17,
                      vR.COD18,vR.UNID18,vR.COD19,vR.UNID19,vR.COD20,vR.UNID20,vR.COD21,vR.UNID21,
                      vR.COD22,vR.UNID22,vR.COD23,vR.UNID23,vR.COD24,vR.UNID24,vR.COD25,vR.UNID25,vR.COD26,vR.UNID26,vR.COD27,vR.UNID27,
                      vR.COD28,vR.UNID28,vR.COD29,vR.UNID29,vR.COD30,vR.UNID30,vR.COD31,vR.UNID31,vR.CODSN31,vR.COD32,vR.UNID32,vR.CODSN32,
                      vR.COD33,vR.UNID33,vR.CODSN33,vR.COD34,vR.UNID34,vR.CODSN34,vR.COD35,vR.UNID35,vR.CODSN35,vR.COD36,vR.UNID36,vR.CODSN36,
                      vR.COD37,vR.UNID37,vR.COD38,vR.UNID38,vR.COD39,vR.UNID39,
                      vR.COD40,vR.UNID40,vR.COD41,vR.UNID41,vR.COD42,vR.UNID42,vR.COD43,vR.UNID43,vR.COD44,vR.UNID44,vR.COD45,vR.UNID45,
                      vR.COD46,vR.UNID46,vR.COD47,vR.UNID47,vR.COD48,vR.UNID48,vR.COD49,vR.UNID49,vR.COD50,vR.UNID50,vR.COD51,vR.UNID51,
                      vR.COD52,vR.UNID52,vR.COD53,vR.UNID53,vR.COD54,vR.UNID54,vR.COD55,vR.UNID55,vR.COD56,vR.UNID56,vR.COD57,vR.UNID57,
                      vR.COD58,vR.UNID58,vR.COD59,vR.UNID59,vR.COD60,vR.UNID60,vR.COD61,vR.UNID61,vR.COD62,vR.UNID62,vR.COD63,vR.UNID63,
                      vR.COD64,vR.UNID64,vR.COD65,vR.UNID65,vR.COD66,vR.UNID66,vR.COD67,vR.UNID67,vR.COD68,vR.UNID68,vR.COD69,vR.UNID69,
                      vR.COD70,vR.UNID70,vR.COD71,vR.UNID71,vR.COD72,vR.UNID72,vR.COD73,vR.UNID73,vR.COD74,vR.UNID74,vR.COD75,vR.UNID75,
                      vR.COD76,vR.UNID76,vR.COD77,vR.UNID77,vR.COD78,vR.UNID78,vR.COD79,vR.UNID79,vR.COD80,vR.UNID80,vR.COD81,vR.UNID81,
                      vR.COD82,vR.UNID82,vR.COD83,vR.UNID83,vR.COD84,vR.UNID84,vR.COD85,vR.UNID85,vR.COD86,vR.UNID86,vR.COD87,vR.UNID87,
                      vR.COD88,vR.UNID88,vR.COD89,vR.UNID89,vR.COD90,vR.UNID90,vR.COD91,vR.UNID91,vR.COD92,vR.UNID92,vR.COD93,vR.UNID93,
                      vR.COD94,vR.UNID94,vR.COD95,vR.UNID95,vR.COD96,vR.UNID96,vR.COD97,vR.UNID97,vR.COD98,vR.UNID98,vR.COD99,vR.UNID99,vR.COD100,vR.UNID100);
       -- Al cuarto se le agrego un sustituto. En la realidad seria del 16 al 21.
       vActual:=vTabla.first;
   end;

   Function Siguiente return Recexp is
      vRecexp Recexp;
   begin
      if VActual is not null then
         loop
            vRecexp.Codart:=vTabla(vActual);
            vActual:=vTabla.next(vActual);
            vRecexp.Canart:=vTabla(vActual);
            vActual:=vTabla.next(vActual);
             -- asi estaria la tabla (s es sustituto): 31, 32, 33s, 34, 35, 36s
            if vActual between 31*2+1 and 31*2+3*(36-31)+1 then  
               vRecexp.Susart:=vTabla(vActual);
               vActual:=vTabla.next(vActual);
            end if;

            exit when ((nvl(vRecexp.Codart,0)<>0 and nvl(vRecexp.Canart,0)<>0) or vActual is null);
            -- La condicion entre parentisis es para descartar los que no tengan codigo o cantidad.
            -- Pues no tiene sentido procesar eso
         end loop;

         return vRecexp;
      else
         return null;
      end if;
   end;

   Function Conteo return number is
   begin
      return vTabla.Count;
   end;

   PROCEDURE RegistraErrorLevPed(Vcaja in varchar2,Vescanid in varchar2,
                     Vsecerr in out number,
                     Verror in varchar2,                     
                     Vtipoerr in char default 'A')  IS
      pragma autonomous_transaction;
   BEGIN
      Vsecerr:=Vsecerr+1;
      insert into ven_escan_bitacora
      (caja,escanid,secuencia,descripcion,tipo)
      values(Vcaja,Vescanid,vsecerr,Verror,vtipoerr);
      commit;
   END RegistraErrorLevPed;


   PROCEDURE InsertaPedido(pcia in varchar2,psuc in char,pdoc in number,vsec in out number,vlote in varchar2,
                           vbod in varchar2,vart in varchar2,vporcdescuento in number,vmedida in varchar2,
                           pcant in number,Vreservado in number,vprecio in number,vimpuesto in number,
    	                   vtotallinea in number,vpdesc1 in number,vpdesc2 in number,vpdesc3 in number, Verror in out varchar2) IS
     psec vendetpedido.secuencia%type;
   BEGIN    
     Verror:=null;  
     if vprecio is null or vbod is null then
        Verror:='ARTICULO '||Vart||' CON PRECIO O BODEGA NULA';
     else
       begin
         select secuencia into psec
         from vendetpedido
         where cia=pcia
         and sucursal=psuc
         and documento=pdoc
         and articulo=vart
         and bodega=vbod
         and lote=vlote
         and medida=vmedida;
       exception
        when no_data_found then
          psec:=null;
       end;
       if psec is null then
         Vsec:=Vsec+1;
         Insert into vendetpedido 
         (cia, sucursal, documento, secuencia, lote, bodega, articulo, porcdescuento, medida, 
          cantidad, facturado, reservado, precio, impuesto, totallinea, pdesc1, pdesc2, pdesc3, caducidad) 
          Values 
         (pcia,psuc ,pdoc ,  vsec,vlote,vbod , vart,vporcdescuento ,vmedida,
          pcant, 0 ,Vreservado , vprecio ,vimpuesto ,vtotallinea , vpdesc1, vpdesc2, vpdesc3,0);
       else
         update vendetpedido
         set cantidad=cantidad+pcant,
             reservado=reservado+vreservado,
             impuesto=impuesto+vimpuesto,
             totallinea=totallinea+vtotallinea
         where cia=pcia
         and sucursal=psuc
         and documento=pdoc
         and secuencia=psec;
       end if;
     end if;   
   END;

   PROCEDURE MarcaAgotado(pcia in char,Vcatalogo in varchar2,Vart in varchar2) IS
      pragma autonomous_transaction;
   BEGIN
     update vendetcatalogo
     set agotado='S'
     where cia=pcia
     and catalogo=Vcatalogo
     and articulo=Vart;
     commit;
   END;

   FUNCTION PremiosInsatisfechos(Vcia in char,Vsuc in char,Vdocumento in number) RETURN VARCHAR2 IS
      Vpremio varchar2(1):='S';
   BEGIN
     select distinct 'S'
     into vpremio
     from venbitpedido
     where cia=Vcia
     and sucursal=Vsuc
     and documento=Vdocumento; 
     return nvl(vpremio,'N');
    exception
     when no_data_found then
     	return 'N';
    END;


   FUNCTION DevOrdenArt(Vcia in char,Vcat in varchar2,Varticulo in varchar2) RETURN number is
      Vorden venclavecatalogo.orden%type;
      vclave venclavecatalogo.clave%type;
   BEGIN
     select clave 
     into vclave
     from vendetcatalogo
     where cia=Vcia
     and catalogo=Vcat
     and articulo=Varticulo; 

     select orden 
     into vorden
     from venclavecatalogo
     where cia=Vcia
     and catalogo=Vcat
     and clave=Vclave; 

     return Vorden;
    exception
     when no_data_found then
     	return 1;
    END;

   FUNCTION DevClaveArt(Vcia in char,Vcat in varchar2,Varticulo in varchar2) RETURN varchar2 is
      vclave venclavecatalogo.clave%type;
   BEGIN
     select clave 
     into vclave
     from vendetcatalogo
     where cia=Vcia
     and catalogo=Vcat
     and articulo=Varticulo; 

     return Vclave;
    exception
     when no_data_found then
     	return 'X';
    END;

   Function VerificaSaldo(pcia in char,plinea in varchar2,pcliente in varchar2) return number is
     vsaldo cxc_credito.saldo%type;
     vmonto cxcperfil.MINSALDOVENCE%type;
     vperfil cxcperfil.perfil%type;
   begin
     select saldo,perfil into vsaldo,vperfil
     from cxc_credito
     where cod_cia=pcia
     and linea=plinea
     and cod_cliente=pcliente;

   	 select MINSALDOVENCE into vmonto
   	 from cxcperfil
   	 where cod_cia=pcia
   	 and perfil=vperfil;
   	 
     return vsaldo-vmonto;
   exception
   	when no_data_found then
   	  return 0;
   end;


End VenLevscan;
/
